<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_12</title>
</head>
<body>
    <h1>Capitulo 12</h1>
    <a>Ejercicio 8</a>

    <script>

        let head;
  
        class Node {
            constructor(val) {
                this.data = val;
                this.next = null;
            }
        }
        
        const copiarNodo = (n) => {

            let main_ptr = head,
                 ref_ptr = head,
                   cont = 0;

            if (head != null) {
                while (cont < n) {
                    if (ref_ptr == null) {
                        console.log(`El nodo ${n} es el ultimo de lista`);
                        return;
                    }
                    ref_ptr = ref_ptr.next;
                    cont++;
                }

                if (ref_ptr == null) {

                    if (head != null) {
                        console.log(`El nodo "${n}" es: "${head.data}" del nodo pasado`);
                    }
                } else {

                    while (ref_ptr != null) {
                        main_ptr = main_ptr.next;
                        ref_ptr = ref_ptr.next;
                    }
                    console.log(`El nodo "${n}" es: "${main_ptr.data}" del nodo pasado`);
                }
            }
        }

        const push = (new_data) => {

            let new_node = new Node(new_data);
            new_node.next = head;
            head = new_node;
        }
    
        push(20);
        push(4);
        push(15);
        push(35);

        copiarNodo(4);

</script>
    
</body>
</html>